︠d71e5b4e-e4a0-4cd4-8fb4-adf21d3f140bi︠
%md
## PyDEC: Adaptando para SageMath
︡cc522a32-7b09-48ec-835b-e7b3c7c65dd6︡{"done":true,"md":"## PyDEC: Adaptando para SageMath"}
︠ccc9465a-3a16-42bd-8579-c529b16de3aas︠
%auto
pyton2 = jupyter('python2')
%default_mode pyton2
sage=jupyter('sagemath')
︡a0b5ddda-e87c-4da2-8579-af0d1aa26814︡{"stderr":"Error in lines 3-3\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1013, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_jupyter.py\", line 32, in __call__\n    raise ValueError(\"You may not run Sage kernels from a Sage worksheet.\\nInstead use the sage_select command in a Terminal to\\nswitch to a different version of Sage, then restart your project.\")\nValueError: You may not run Sage kernels from a Sage worksheet.\nInstead use the sage_select command in a Terminal to\nswitch to a different version of Sage, then restart your project.\n"}︡{"done":true}︡︡{"done":true}
︠08134429-dea3-4e14-b220-d565ed62a931s︠
#pacotes
from numpy import array, transpose, dot   # criar arrays, calcula a transposta de uma array, produto de matrizes
from numpy.linalg import inv   # calcula a matrix inversa
from pydec import abstract_simplicial_complex,simplex_array, simplicial_complex, simplicial_mesh,d,cochain  # d calcula o bordo e desta
from pydec.vis.draw import triplot # plota malhas triângulares
#from pydec.mesh import simplicial_mesh
#from pydec.dec import simplicial_complex
︡be6fa40f-e78f-4598-9e68-aa56ce42990a︡{"done":true}︡
︠1afcc444-3b01-4fd1-a19f-7685c3830decis︠
%md <div align='center'><h3>Simples Triângulo</h3></div>
︡1aafd21b-efb7-49f9-ae2e-e2fdbb34ebb0︡{"md":"<div align='center'><h3>Simples Triângulo</h3></div>"}︡{"done":true}︡
︠9156e690-a852-48f3-a9f4-60cd7df618bds︠

︡02bdbb2d-cc21-4fcf-ad41-67181f64e804︡{"done":true}︡
︠9b499458-2884-4dec-a562-2d55f7313e0ds︠
%sage
v_0=vector([0,0])
v_1=vector([1,0])
v_2=vector([0,1])
cc=(v_0+v_1)/2
a = polygon2d([v_0,v_1,v_2], fill=False, axes=False)
p=point([v_0,v_1,v_2,],size=30, color='red')
v0=text('$0=(0,0)$',(-0.03,0), horizontal_alignment='right')
v1=text('$v_1=(1,0)$',(1.03,0), horizontal_alignment='left')
v2=text('$v_2=(0,1)$',(-0.03,1), horizontal_alignment='right')
cc=text('$cc=(1/2,1/2)$',(0.53,0.5), horizontal_alignment='left')
v0v1=arrow(v_0,(0.5,0),  width=1, arrowsize=2)
v1v2=arrow(v_1,(1/2,1/2), width=1, arrowsize=2)
v0v2=arrow(v_0,(0,1/2), width=1, arrowsize=2)
T=a+p+v0+v1+v2+v0v1+v1v2+v0v2
show(T, figsize=[2,2])
︡2590788b-9a30-457e-9972-f47ac7e79d7e︡{"file":{"filename":"/home/user/.sage/temp/project-89cacd19-01ae-452b-937b-cea665ff0bbd/189/tmp_KcL_ik.svg","show":true,"text":null,"uuid":"19046be4-5ef4-486b-b617-666187e2cf7e"},"once":false}︡{"done":true}︡
︠4985c286-f255-460c-8d7b-da8c0c5b4ecb︠
Vt = [[0,0],[1,0],[0.5,1]] # spatial coordinates
St = [[0,1,2]]           # indicies vertices

sct=simplicial_complex((Vt,St))
boundary_triangulo0=sct[0].d  #vertice boundary operator 
boundary_triangulo1=sct[1].d  # edges boundary operator

d0=boundary_triangulo0.toarray()   # transforma matrix sparsa em array
d1=boundary_triangulo1.toarray()   # transforma matrix sparsa em array
h0=sct[0].star # Hodge Star Operador act 0-form
h1=sct[1].star
print d0, '\n\n'
print d1, '\n\n'

print h0.toarray(), '\n\n'

print h1.toarray(), '\n\n'

print reduce(dot,[-inv(h0),d0.T


triplot(Vt, St)
︡3660c174-fce3-49b9-84b4-30dadb851ce4︡{"stdout":"[[-1  1  0]\n [-1  0  1]\n [ 0 -1  1]] \n\n\n[[ 1 -1  1]] \n\n\n[[ 0.171875  0.        0.      ]\n [ 0.        0.171875  0.      ]\n [ 0.        0.        0.15625 ]] \n\n\n[[ 0.375  0.     0.   ]\n [ 0.     0.25   0.   ]\n [ 0.     0.     0.25 ]] \n\n\n"}︡{"file":{"filename":"/tmp/tmpOY2BHi.png","show":true,"text":null,"uuid":"a8f9c900-938e-4fbc-9644-17ef6b7c7699"},"once":false}︡{"done":true}︡
︠95408328-270a-42ed-90f1-c6f4d491d251s︠
hodget0=sct[0].star # Hodge Star Operador act 0-form
hodget1=sct[1].star # Hodge Star Operador act 1-form

ht0=hodget0.toarray()
ht1=hodget1.toarray()
print 'ht0','=',ht0, '\n\n'
print 'ht1','=',ht1
︡47f0bf86-421a-41a8-9018-150b548f9e95︡{"stdout":"ht0 = [[ 0.194125  0.        0.      ]\n [ 0.        0.154625  0.      ]\n [ 0.        0.        0.15125 ]] \n\n\nht1 = [[ 0.395  0.     0.   ]\n [ 0.     0.35   0.   ]\n [ 0.     0.     0.15 ]]\n"}︡{"done":true}︡
︠5538f3e2-2468-4e49-904f-ab55af279b1d︠

︡c8b42dfe-95cc-47d0-822f-9a8b4bb6c13e︡
︠9d3b12c1-1006-464d-9bc0-90ed54886b54s︠
sct=compute_circumcenters
︡c45bf2a9-75cb-4728-b165-7cc935d0e84c︡{"html":"<pre style=\"font-family:monospace;\"><span style=\"color: #aa0000\">---------------------------------------------------------------------------</span>\n</pre>"}︡{"html":"<pre style=\"font-family:monospace;\"><span style=\"color: #aa0000\">NameError</span>                                 Traceback (most recent call last)\n</pre>"}︡{"html":"<pre style=\"font-family:monospace;\"><span style=\"color: #00aa00\">&lt;ipython-input-25-588a565cbb99&gt;</span> in <span style=\"color: #00aaaa\">&lt;module&gt;</span><span style=\"color: #0000aa\">()</span>\n<span style=\"color: #00aa00\">----&gt; 1</span><span style=\"color: #aa0000\"> </span>sct<span style=\"color: #0000aa\">=</span>compute_circumcenters<span style=\"color: #0000aa\"></span>\n\n</pre>"}︡{"html":"<pre style=\"font-family:monospace;\"><span style=\"color: #aa0000\">NameError</span>: name 'compute_circumcenters' is not defined\n</pre>"}︡{"done":true}︡
︠35683075-5574-468c-86e4-52c89b23c38bs︠
coderivative1=dot(dot(-inv(ht0),transpose(bt0)),ht1)   #coderivative
print coderivative1
︡2135db5c-b90a-48cc-b262-ef949653113c︡{"stdout":"[[ 2.03477141  1.80296201  0.        ]\n [-2.5545675   0.          0.97008892]\n [ 0.         -2.31404959 -0.99173554]]\n"}︡{"done":true}︡
︠805b9372-8035-48c4-9a8d-3562a003e310s︠
︡6b7d132d-ef14-40f5-b072-45fe58901052︡{"done":true}︡
︠5f3a32b1-a04e-4e4a-9fb1-e1e366e42bd5i︠
%md
 <div align='center'><h3>Malha Triângular</h3></div>
<img src='https://cloud.sagemath.com/89cacd19-01ae-452b-937b-cea665ff0bbd/raw/Figuras/triangulos1.png?random=0.37155568163073305' width=500  title='Simplicial Mesh com vertices de simplices enumerados'>
<img src='https://cloud.sagemath.com/89cacd19-01ae-452b-937b-cea665ff0bbd/raw/Figuras/triangulos2.png?random=0.17683476738233606' width=600 title='Simplicial Mesh com arestas orientadas e triângulos'>



︡c7e9ac2e-b21f-4076-9e3d-975874959005︡{"done":true,"md":" <div align='center'><h3>Malha Triângular</h3></div>\n<img src='https://cloud.sagemath.com/89cacd19-01ae-452b-937b-cea665ff0bbd/raw/Figuras/triangulos1.png?random=0.37155568163073305' width=500  title='Simplicial Mesh com vertices de simplices enumerados'>\n<img src='https://cloud.sagemath.com/89cacd19-01ae-452b-937b-cea665ff0bbd/raw/Figuras/triangulos2.png?random=0.17683476738233606' width=600 title='Simplicial Mesh com arestas orientadas e triângulos'>"}
︠1a0f79b5-82be-4562-9e72-050144ebc559s︠
V=[[0,0],[1,0],[2,0],[1,1],[2,1]] # coordenadas espaciais dos vertices
S_0=[[0],[1],[2],[3],[4]]        # vertices (0 simplex)
S_1=[[0,1],[0,3],[1,2],[1,3],[2,3],[2,4],[3,4]] #arestas(1-simplex)
S_2=[[0,1,3],[1,2,3],[2,4,3]]     # triângulo (2-simplex)
︡566df886-5c4d-4b1e-9085-1a2dd919866d︡{"done":true}︡
︠9d5d1452-0f8b-48d0-acd3-ce3a1647fe5bs︠
sc=simplicial_complex((V,S_2)) #object simplicial complex
boundary0=sc[0].d    #vertice boundary operator
boundary1=sc[1].d    #edges boundary operator

b0=boundary0.toarray()
b1=boundary1.toarray()
boundarymesh=sc.boundary()
print boundarymesh, '\n'
print 'b0','=',b0,'\n\n'
print 'b1','=',b1, '\n\n'

#print simplex_array.simplex_array_boundary(array(S_2), array([0,1,2]))[1].toarray()
︡f67598e8-559c-4ccc-adbb-3e558f5b9a4d︡{"stdout":"[simplex((0, 1),parity=0), simplex((1, 2),parity=0), simplex((0, 3),parity=0), simplex((3, 4),parity=0), simplex((2, 4),parity=0)] \n\nb0 = [[-1  1  0  0  0]\n [-1  0  0  1  0]\n [ 0 -1  1  0  0]\n [ 0 -1  0  1  0]\n [ 0  0 -1  1  0]\n [ 0  0 -1  0  1]\n [ 0  0  0 -1  1]] \n\n\nb1 = [[ 1 -1  0  1  0  0  0]\n [ 0  0  1 -1  1  0  0]\n [ 0  0  0  0 -1  1 -1]] \n\n\n"}︡{"done":true}︡
︠8877be27-4009-40f2-b320-5b868b0e5ae0s︠
hodge0=sc[0].star # Hodge Star Operador 0-simplex
hodge1=sc[1].star # Hodge Star Operador 1-simplex

h0=hodge0.toarray()
h1=hodge1.toarray()
print 'h0','=',h0, '\n\n'
print 'h1','=',h1, '\n\n'


︡7b990608-0dfb-471e-88bb-caa7b9ea5fb5︡{"stdout":"h0 = [[ 0.125  0.     0.     0.     0.   ]\n [ 0.     0.5    0.     0.     0.   ]\n [ 0.     0.     0.25   0.     0.   ]\n [ 0.     0.     0.     0.375  0.   ]\n [ 0.     0.     0.     0.     0.25 ]] \n\n\nh1 = [[ 0.5  0.   0.   0.   0.   0.   0. ]\n [ 0.   0.   0.   0.   0.   0.   0. ]\n [ 0.   0.   0.5  0.   0.   0.   0. ]\n [ 0.   0.   0.   1.   0.   0.   0. ]\n [ 0.   0.   0.   0.   0.   0.   0. ]\n [ 0.   0.   0.   0.   0.   0.5  0. ]\n [ 0.   0.   0.   0.   0.   0.   0.5]] \n\n\n"}︡{"stderr":"pydec/dec/simplicial_complex.py:175: RuntimeWarning: divide by zero encountered in divide\n  data.star_inv = sparse.spdiags([1.0/stardiag],[0], N, N, format='csr')\n"}︡{"done":true}︡
︠89441a74-8e4a-4409-a859-1f1e24bc2eb5s︠
coderivative1=dot(dot(-inv(h0),transpose(b0)),h1)   #coderivative
print coderivative1
︡0efea272-9b6b-4153-9d75-1a09df05617d︡{"stdout":"[[ 4.          0.          0.          0.          0.          0.          0.        ]\n [-1.          0.          1.          2.          0.          0.          0.        ]\n [ 0.          0.         -2.          0.          0.          2.          0.        ]\n [ 0.          0.          0.         -2.66666667  0.          0.\n   1.33333333]\n [ 0.          0.          0.          0.          0.         -2.         -2.        ]]\n"}︡{"done":true}︡
︠0b6ca75b-a04c-493d-8b99-cb16255103a6s︠

︡012c5d05-1657-4f36-bdce-6b580a4cbd59︡{"done":true}︡
︠f9df69be-3744-43c8-8ff8-e050fd8067f4i︠
%md 
<div align='center'><h3> Complex abstrato: Faixa de Mobius Discreta</h3></div>
<div align='center'><img src='https://cloud.sagemath.com/89cacd19-01ae-452b-937b-cea665ff0bbd/raw/Figuras/manifolds1.png?random=0.19675942886456887' width=400 title='Faixa de Mobius Discreta'></div>
︡130a7b02-c6eb-4412-bd95-119a0f49aa6d︡{"done":true,"md":"<div align='center'><h3> Complex abstrato: Faixa de Mobius Discreta</h3></div>\n<div align='center'><img src='https://cloud.sagemath.com/89cacd19-01ae-452b-937b-cea665ff0bbd/raw/Figuras/manifolds1.png?random=0.19675942886456887' width=400 title='Faixa de Mobius Discreta'></div>"}
︠b19b4d14-5b11-43a9-97cc-e5100c27549cs︠
M=array([[0,1,3],[0,3,5], [3,2,5],[5,2,4],[2,0,4],[0,1,4]]) # manifold(Faixa de Mobius Discreta)
abst_cplx=abstract_simplicial_complex(M)
︡93c07159-a707-44b5-a492-434242ba7547︡{"done":true}︡
︠174e4f98-01a5-48b8-ac6c-fe4b966ef3e7s︠
︡fa1efb37-849c-4723-953e-f68897553431︡{"done":true}︡
︠93ff2f73-c21e-4c62-a208-12d84ea4ead6s︠
︡4bf99c13-474d-4f88-8b6d-d116ae408b16︡{"done":true}︡
︠f56d7abe-254f-495c-b857-4146c459805bs︠
︡038c0b85-e642-47e1-b53a-2ee8c9a422d7︡{"done":true}
︠8aeb3456-c69c-419e-b9fc-15dd0feedd55s︠
Vth= [[2,1,-1], [3,0,1], [2,-1,3], [0,-7,0]] # spatial coordinates
Sth= [[0,1,2,3]]     # indicies vertices

sct=simplicial_complex((Vth,Sth))
print sct
︡2dd4f008-94b0-4b51-a8ad-6e337a6d9228︡{"stdout":"simplicial_complex:\n  complex:\n            1:  3-simplices\n            4:  2-simplices\n            6:  1-simplices\n            4:  0-simplices\n\n"}︡{"done":true}
︠84922409-c180-4167-acd0-58b026fa7d61s︠
print sct[0].d.toarray()

︡c15b64b3-d51b-452d-8b67-e601e7ec3fa0︡{"stdout":"[[-1  1  0  0]\n [-1  0  1  0]\n [-1  0  0  1]\n [ 0 -1  1  0]\n [ 0 -1  0  1]\n [ 0  0 -1  1]]\n"}︡{"done":true}
︠b95cd4ce-4135-447d-b08b-059215795e3cs︠
print sct[0].star.toarray()
︡e5dab545-6e4a-4691-9557-83a862fdeb16︡{"stdout":"[[ 6.40722222  0.          0.          0.        ]\n [ 0.          7.08793924  0.          0.        ]\n [ 0.          0.          9.8506705   0.        ]\n [ 0.          0.          0.          4.94002463]]\n"}︡{"done":true}
︠de32733a-ff93-4c23-85aa-8c990def86d4s︠
︡9c0b7d75-2a54-4b97-8633-5e47126c57ce︡{"done":true}︡
︠803c26cc-27ab-433d-a641-45f9838942b8s︠
Vth2=[[1,1,1], [1,-1,-1], [-1,1,-1], [-1,-1,1]]
Sth2=[[0,1,2,3]]
sct2=simplicial_complex((Vth,Sth))
︡e3345340-7004-4da9-b26d-682e495d8974︡{"stderr":"Error in lines 3-3\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1009, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nNameError: name 'simplicial_complex' is not defined\n"}︡{"done":true}︡
︠ecc252f7-a47f-43c3-89a8-f1259009d834s︠
print sct2[1].d.toarray()
︡1ce9df5a-6853-444b-9e5e-9f063880ed70︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1009, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nNameError: name 'sct2' is not defined\n"}︡{"done":true}︡
︠b508bfcd-b716-4e78-a3db-7a1b97577f00s︠
print sct2[0].d.toarray()
︡ea6df69b-be0d-4b59-b50c-0bce3baa2871︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1009, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nNameError: name 'sct2' is not defined\n"}︡{"done":true}︡
︠42f0fcc6-8b30-49a6-9688-6e6ddd2cb30fs︠
print sct2[0].star.toarray()
︡b9dce170-0a69-4cf6-8e81-87e7b356ee3e︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1009, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nNameError: name 'sct2' is not defined\n"}︡{"done":true}︡
︠b442bfe8-8521-445c-9f28-a4b11410eba2s︠
D0=sct[0].d
H1=sct[1].star
B=sct2.boundary()
L=array(dot(D0.T.todense(),dot(H1.todense(),D0.todense())))
print B
︡c063a381-e7e3-4b3e-917d-31820173f2dd︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1009, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nNameError: name 'sct' is not defined\n"}︡{"done":true}︡
︠422f06a4-1c49-47ad-b431-3e3a2e628a2bs︠
+print L
︡405544ab-365a-49bd-b3db-3617477ca4b4︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1009, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"<string>\", line 1\n    +print L\n         ^\nSyntaxError: invalid syntax\n"}︡{"done":true}
︠1c1c556c-dabf-4f4b-809d-4115faa93db9s︠
from scipy.linalg import eig, solve,lstsq,inv, det, norm

solve(L,array([0,0,0,0]))
︡af9a1b4b-f4db-4f65-8a31-18bade3163e9︡{"stderr":"Error in lines 2-2\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1009, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nNameError: name 'L' is not defined\n"}︡{"done":true}︡
︠76f5df98-d0ad-4c1c-aa3c-3b52a51da415s︠
︡0d1407f3-58b1-42bb-950e-f714c32a57d3︡{"done":true}︡
︠a3e66dc2-4f96-4cb6-8e41-bdae369e09dds︠

︡2d5cdd81-e244-4977-ae18-4ef3fb6d746d︡{"done":true}︡









